/// <reference types="node" />
import * as http from "http";
export declare type HttpMethod = "GET" | "POST";
export declare type HttpHandler = (request: http.IncomingMessage, response: http.ServerResponse, requestData: IRequestData) => Promise<any>;
export interface ILookupTable {
    [key: string]: string;
}
export interface IRequestData {
    requestContext: {
        resourcePath: string;
        httpMethod: HttpMethod;
    };
    queryString: ILookupTable;
    body?: any;
    rawBody?: any;
    headers: http.IncomingHttpHeaders;
    normalizedHeaders: http.IncomingHttpHeaders;
    pathParameters: ILookupTable;
}
export declare class SlimJim {
    private server;
    private handlerMap;
    constructor();
    registerEndpoint(method: HttpMethod, route: string, handler: HttpHandler, parseBody: boolean): void;
    get(route: string, handler: HttpHandler): void;
    post(route: string, handler: HttpHandler, parseBody: boolean): void;
    listen(port: number | string, cb: () => void): void;
    private pathMatch(method, route);
}
