"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
exports.__esModule = true;
var http = require("http");
var querystring = require("querystring");
var url = require("url");
var util_1 = require("util");
var default404Handler = {
    handler: function (req, res) { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            res.statusCode = 404;
            res.end();
            return [2 /*return*/];
        });
    }); },
    parseBody: false
};
var SlimJim = (function () {
    function SlimJim() {
        var _this = this;
        var lib = http;
        this.server = lib.createServer(function (req, res) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            var urlInfo, handler, parsedObj, resObj, inputBuffer_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        urlInfo = url.parse(req.url, true);
                        handler = this.pathMatch(req.method, urlInfo.pathname);
                        parsedObj = {
                            body: null,
                            headers: req.headers,
                            normalizedHeaders: req.headers,
                            pathParameters: {},
                            queryString: urlInfo.query,
                            rawBody: null,
                            requestContext: {
                                httpMethod: req.method,
                                resourcePath: req.url
                            }
                        };
                        if (!!handler.parseBody) return [3 /*break*/, 2];
                        return [4 /*yield*/, handler.handler(req, res, parsedObj)];
                    case 1:
                        resObj = _a.sent();
                        if (util_1.isObject(resObj)) {
                            res.setHeader("Content-Type", "application/json");
                            res.end(JSON.stringify(resObj));
                        }
                        else {
                            res.end(resObj);
                        }
                        return [3 /*break*/, 3];
                    case 2:
                        inputBuffer_1 = [];
                        req.on("data", function (chunk) {
                            inputBuffer_1.push(chunk);
                        });
                        req.on("end", function () { return __awaiter(_this, void 0, void 0, function () {
                            var rawBody, contentType, bodyContent, resObj;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        rawBody = (inputBuffer_1.length === 1) ? inputBuffer_1[0].toString("utf8") :
                                            Buffer.concat(inputBuffer_1).toString("utf8");
                                        contentType = req.headers["content-type"];
                                        bodyContent = attemptParse(contentType, rawBody);
                                        parsedObj.rawBody = rawBody;
                                        parsedObj.body = bodyContent;
                                        return [4 /*yield*/, handler.handler(req, res, parsedObj)];
                                    case 1:
                                        resObj = _a.sent();
                                        if (util_1.isObject(resObj)) {
                                            res.setHeader("Content-Type", "application/json");
                                            res.end(JSON.stringify(resObj));
                                        }
                                        else {
                                            res.end(resObj);
                                        }
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        _a.label = 3;
                    case 3: return [2 /*return*/];
                }
            });
        }); });
        this.handlerMap = {
            GET: {},
            POST: {}
        };
    }
    SlimJim.prototype.registerEndpoint = function (method, route, handler, parseBody) {
        var handlerData = {
            handler: handler,
            parseBody: parseBody
        };
        switch (method) {
            case "GET":
                this.handlerMap.GET[route] = handlerData;
                break;
            case "POST":
                this.handlerMap.POST[route] = handlerData;
                break;
            default:
                throw new Error("Unsupported method");
        }
    };
    SlimJim.prototype.get = function (route, handler) {
        return this.registerEndpoint("GET", route, handler, false);
    };
    SlimJim.prototype.post = function (route, handler, parseBody) {
        return this.registerEndpoint("POST", route, handler, parseBody);
    };
    SlimJim.prototype.listen = function (port, cb) {
        this.server.listen(port, cb);
    };
    SlimJim.prototype.pathMatch = function (method, route) {
        var routeMap = null;
        var handler = null;
        switch (method) {
            case "GET":
                routeMap = this.handlerMap.GET;
                break;
            case "POST":
                routeMap = this.handlerMap.POST;
                break;
            default:
                return default404Handler;
        }
        handler = routeMap[route];
        return (handler != null) ? handler : default404Handler;
    };
    return SlimJim;
}());
exports.SlimJim = SlimJim;
function attemptParse(contentType, obj) {
    if (contentType == null) {
        return obj;
    }
    try {
        switch (contentType) {
            case "application/json":
                return JSON.parse(obj);
            case "application/x-www-form-urlencoded":
                return querystring.parse(obj);
            default:
                return obj;
        }
    }
    catch (err) {
        return obj;
    }
}
